classification
Title: PEP 453 implementation tracking issue
Type: enhancement Stage: committed/rejected
Components: Versions: Python 3.4
process
Status: closed Resolution: fixed
Dependencies: 19406 19550 19551 19552 19553 Superseder:
Assigned To: ncoghlan Nosy List: bkabrda, dstufft, larry, loewis, ncoghlan, ned.deily, tshepang, vinay.sajip
Priority: normal Keywords:

Created on 2013-10-22 11:48 by ncoghlan, last changed 2014-01-03 05:20 by ncoghlan. This issue is now closed.

Messages (18)
msg200923 - (view) Author: Nick Coghlan (ncoghlan) * (Python committer) Date: 2013-10-22 11:48
This is the overall tracking issue for the implementation of PEP 453. The following subtasks will be created as separate issues:

- update the Installing Python Modules documentation to reference www.pip-installer.org in Python 2.7, 3.3 and 3.4 (ncoghlan)
- initial implementation of ensurepip (dstufft)
- Python 3.4 documentation updates for ensurepip (dstufft and/or ncoghlan)
- Windows installer updates, including PATH manipulation updates (MvL?)
- Mac OS X installer updates (Ned?)
- venv and pyvenv updates (dstufft? TBC)
msg200925 - (view) Author: Nick Coghlan (ncoghlan) * (Python committer) Date: 2013-10-22 11:50
One more task to track - updating to the latest upstream pip before beta 2.
msg200945 - (view) Author: Vinay Sajip (vinay.sajip) * (Python committer) Date: 2013-10-22 13:25
venv shouldn't need any changes. The pyvenvex.py [1] script I posted to distutils-sig installs setuptools and pip into venvs, and it can be used to update pyvenv (where AFAICT changes are only required to change where the pip to be installed comes from).

[1] https://gist.github.com/vsajip/4673395
msg200950 - (view) Author: Nick Coghlan (ncoghlan) * (Python committer) Date: 2013-10-22 13:41
Check PEP 453 again: http://www.python.org/dev/peps/pep-0453/#changes-to-virtual-environments

Rather than only changing pyvenv, the API in the PEP is to add "with_pip" parameters to the venv module API, so that anyone building pyvenv style tools on top of venv can easily request installation of pip by passing "with_pip=True". The change to pyvenv is then to just add the --without-pip flag (since the default is inverted for the two interfaces - library API is opt-in for backwards compatibility, tool CLI is opt-out)
msg200956 - (view) Author: Nick Coghlan (ncoghlan) * (Python committer) Date: 2013-10-22 14:14
Just clarifying how I plan to track this: as we start specific tasks, we'll
create new issues and make this one depend on them. That seems better to me
than creating a whole raft of issues up front that are then depending on
each other.
msg201345 - (view) Author: Nick Coghlan (ncoghlan) * (Python committer) Date: 2013-10-26 12:46
First two working issues created:

Issue 19406 for the addition of ensurepip and its docs
Issue 19407 for the Installing Python Modules updates
msg202617 - (view) Author: Nick Coghlan (ncoghlan) * (Python committer) Date: 2013-11-11 11:55
New subtasks:

Issue 19550: Windows installer integration
Issue 19551: Mac OS X installer integration
Issue 19552: venv module and pyvenv integration
Issue 19553: "make install" and "make altinstall" integration 	open
msg203772 - (view) Author: Nick Coghlan (ncoghlan) * (Python committer) Date: 2013-11-22 14:40
Issue 19693 covers an anomaly where "make altinstall && make install" doesn't quite do the same thing as "make install" (the "pip3" script will be missing in the former case)
msg203779 - (view) Author: Nick Coghlan (ncoghlan) * (Python committer) Date: 2013-11-22 15:10
Issue 19694 is a new issue for one of the buildbots objecting to the new venv tests.
msg203950 - (view) Author: Nick Coghlan (ncoghlan) * (Python committer) Date: 2013-11-23 01:48
Created issue 19728 to track what is needed before the installation of pip can be made the default in the installers (at least for Windows, but I assume MvL's concerns would apply equally to the Mac OS X installer)
msg204169 - (view) Author: Nick Coghlan (ncoghlan) * (Python committer) Date: 2013-11-24 02:50
Issue 19744 covers better handling of the case where SSL/TLS support is not available in the current Python.
msg204294 - (view) Author: Nick Coghlan (ncoghlan) * (Python committer) Date: 2013-11-25 05:03
Issue 19734 covers the fact that pip environment variable settings impact venv and ensurepip
msg205109 - (view) Author: Nick Coghlan (ncoghlan) * (Python committer) Date: 2013-12-03 12:22
Issue 19766 covers the fact that the vendored urllib3 needs to be updated in order to handle the case where Python is built without threading support.
msg205110 - (view) Author: Nick Coghlan (ncoghlan) * (Python committer) Date: 2013-12-03 12:23
Upgrading to release blocker status, since we'd prefer to have everything we can sorted before beta 2
msg206845 - (view) Author: Nick Coghlan (ncoghlan) * (Python committer) Date: 2013-12-23 06:43
Issue 20053 covers the fact that the default pip config file affects ensurepip and venv.
msg207174 - (view) Author: Martin v. Löwis (loewis) * (Python committer) Date: 2014-01-02 16:52
I propose to downgrade this from "release blocker" again. "prefer to have everything we can sorted" is IMO not a sufficient rationale to block the release; if taken literally, 3.4 could never ever release since it doesn't have everything sorted out that I would personally want to sort out some time in Python.

If individual subissues should block the release, the should be promoted.
msg207200 - (view) Author: Nick Coghlan (ncoghlan) * (Python committer) Date: 2014-01-03 02:17
Agreed, it was mostly to ensure we reviewed the status to make sure we were
happy with progress. The only remaining "must fix" item is the docs update,
and that's shouldn't block beta 2 (although I'll still try to get at least
an initial version done now that pip 1.5 is released).
msg207205 - (view) Author: Nick Coghlan (ncoghlan) * (Python committer) Date: 2014-01-03 05:20
Actually, with the docs update being the only remaining "this really should be done before 3.4 is released" issue related to PEP 453, I think this tracking issue has now served its purpose.

So, closing this umbrella issue now, since issue 19407 covers the docs update.

Thanks again to everyone that contributed the various bits and pieces needed to make the PEP a reality :)
History
Date User Action Args
2014-01-03 05:20:09ncoghlansetstatus: open -> closed
messages: + msg207205

dependencies: - PEP 453: update the "Installing Python Modules" documentation
resolution: fixed
stage: committed/rejected
2014-01-03 02:21:17loewissetpriority: release blocker -> normal
2014-01-03 02:17:00ncoghlansetmessages: + msg207200
2014-01-02 16:52:11loewissetmessages: + msg207174
2013-12-23 06:43:11ncoghlansetmessages: + msg206845
2013-12-03 12:23:15ncoghlansetpriority: normal -> release blocker
nosy: + larry
messages: + msg205110

2013-12-03 12:22:40ncoghlansetmessages: + msg205109
2013-11-25 05:03:40ncoghlansetmessages: + msg204294
2013-11-24 02:50:13ncoghlansetmessages: + msg204169
2013-11-23 01:48:32ncoghlansetmessages: + msg203950
2013-11-22 15:10:26ncoghlansetmessages: + msg203779
2013-11-22 14:40:25ncoghlansetmessages: + msg203772
2013-11-11 11:56:09ncoghlansetdependencies: + PEP 453: Windows installer integration, PEP 453: Mac OS X installer integration, PEP 453: venv module and pyvenv integration, PEP 453: "make install" and "make altinstall" integration, - Potential overflows due to incorrect usage of PyUnicode_AsString., test_wave.py converted to unittest, test_select.py converted to unittest, Compact int and float freelists
2013-11-11 11:55:38ncoghlansetdependencies: + Potential overflows due to incorrect usage of PyUnicode_AsString., test_wave.py converted to unittest, test_select.py converted to unittest, Compact int and float freelists
messages: + msg202617
2013-11-05 11:53:49bkabrdasetnosy: + bkabrda
2013-10-26 12:46:17ncoghlansetdependencies: + PEP 453: add the ensurepip module, PEP 453: update the "Installing Python Modules" documentation
messages: + msg201345
2013-10-22 22:54:43tshepangsetnosy: + tshepang
2013-10-22 14:14:14ncoghlansetmessages: + msg200956
2013-10-22 13:41:51ncoghlansetmessages: + msg200950
2013-10-22 13:25:17vinay.sajipsetmessages: + msg200945
2013-10-22 12:01:18ncoghlansetnosy: + loewis, vinay.sajip, ned.deily, dstufft
2013-10-22 11:50:10ncoghlansetmessages: + msg200925
2013-10-22 11:48:34ncoghlancreate